﻿using GrapeCity.CalcEngine;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FormulaToValueCells
{
    class CountIfLessThanFunction : GrapeCity.CalcEngine.Function
    {
        public CountIfLessThanFunction() : base("COUNTIFLESSTHAN", 2, 2, GrapeCity.CalcEngine.FunctionAttributes.Number) { }
        protected override void Evaluate(IArguments arguments, IValue result)
        {
            IValue range = arguments[0];
            if (range.ValueType != GrapeCity.CalcEngine.ValueType.Reference)
            {
                arguments.EvaluationContext.Error = CalcError.Value;
                result.SetValue(CalcError.Value);
            }
            else
            {
                IEvaluationContext evaluationContext = arguments.EvaluationContext;
                double criteria = arguments[1].GetNumber(evaluationContext);
                IReferenceSource referenceSource = range.GetReferenceSource(evaluationContext);
                RangeReference rangeRef = range.GetReference(evaluationContext, 0);
                int count = 0;
                for (int c = rangeRef.Column; c <= rangeRef.Column2; c++)
                {
                    for (int r = rangeRef.Row; r <= rangeRef.Row2; r++)
                    {
                        referenceSource.GetValue(evaluationContext, r, c, result);
                        double cellValue = result.GetNumber(evaluationContext);
                        if (cellValue < criteria)
                        {
                            count++;
                        }
                    }
                }
                result.SetValue(evaluationContext, count);
            }
        }
    }
}
