﻿using FarPoint.Excel;
using FarPoint.Win.Spread;
using GrapeCity.Spreadsheet;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FormulaToValueCells
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            fpSpread1.AsWorkbook().WorkbookSet.CalculationEngine.CalcFeatures |= GrapeCity.Spreadsheet.CalcFeatures.DynamicArray;
            fpSpread1.AddCustomFunction(new TaxValueFunction());
            fpSpread1.AddCustomFunction(new CountIfLessThanFunction());

            fpSpread1.ActiveSheet.Cells[0, 2, 8, 2].Formula = "TAXVALUE(A1)";
            fpSpread1.ActiveSheet.Cells[0, 5].Formula = "UNIQUE(A1:A9)";
            fpSpread1.ActiveSheet.Cells[10,0].Formula = "COUNTIFLESSTHAN(A1:A9,65)";

            var cell = fpSpread1.ActiveSheet.AsWorksheet().Cells[0,5];
            var formula = cell.Formula;
            if (formula != null)
            {
                //var ctx = fpSpread1.AsWorkbook().WorkbookSet.CalculationEngine.EvaluationContext;
                //var value = fpSpread1.AsWorkbook().WorkbookSet.CalculationEngine.Evaluate(formula, fpSpread1.ActiveSheet.AsWorksheet(),
                //    new CellReference(cell.Row, cell.Column));
                var range = fpSpread1.ActiveSheet.AsWorksheet().Cells[0, 5, 8, 5];
                var newRange = fpSpread1.ActiveSheet.AsWorksheet().Cells[0, 7, 8, 7];
                range.Copy(newRange, ManipulationOptions.Values | ManipulationOptions.Comments | ManipulationOptions.ConditionalFormatting | ManipulationOptions.Formats | ManipulationOptions.Formatting | ManipulationOptions.NumberFormats);
                                     
                var newCell = fpSpread1.ActiveSheet.AsWorksheet().Cells[0, 9];
                cell.Copy(newCell, ManipulationOptions.All ^ ManipulationOptions.Formulas);
            }

        }

        private void exportBtn_Click(object sender, EventArgs e)
        {
            try
            {
                fpSpread1.SaveExcel("c:/temp/TestResult.xlsx", FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat | FarPoint.Excel.ExcelSaveFlags.NoFormulas);
                MessageBox.Show("File Saved at c:/temp/TestResult.xlsx");
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error saving file");
            }
        }
    }
}
