﻿using GrapeCity.CalcEngine;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FormulaToValueCells
{
    public class TaxValueFunction : GrapeCity.CalcEngine.Function
    {
        public TaxValueFunction() : base("TAXVALUE", 1, 2, FunctionAttributes.SingleCell | FunctionAttributes.Number) { }
        protected override void Evaluate(IArguments arguments, IValue result)
        {
            IEvaluationContext context = arguments.EvaluationContext;
            double num = arguments[0].GetNumber(context);
            double taxrate = arguments.Count > 1 ? arguments[1].GetNumber() : 0.15;
            result.SetValue(null, num - (num * taxrate));
        }
    }
}
